<template>
  <div class="flex flex-col pb-8 h-full">
    <ReferOutModal
      v-if="refer"
    />
    <common-navbar
      :current-status-number="currentStatusNumber"
    >
      <CommonLogo v-if="currentQuiz.displayLogo"/>
      <img
        v-else-if="currentQuiz.displayBackBtn"
        src="@/assets/img/icons/arrow.png"
        class="w-5 cursor-pointer"
        alt="back-btn"
      >
      <div v-else></div>
      <div
        class="text-center text-base font-semibold max-w-quiz absolute left-1/2 transform -translate-x-1/2"
        v-if="currentQuiz.title"
      >
        {{ currentQuiz.title }}
      </div>
      <div
        class="border border-green-light-2 z-10 flex rounded-md py-2 px-5 text-sm font-bold cursor-pointer"
        @click="isHelpDisplayed = true"
      >
        Help?
      </div>
    </common-navbar>
    <main class="relative flex-auto mt-8 flex flex-col px-5 sm:px-0 max-w-quiz w-full mx-auto">
      <transition name="fast-fade">
        <div class="rounded-lg bg-green-n-black absolute top-0 p-5 flex flex-col z-20" v-if="isHelpDisplayed">
          <div class="text-xl font-semibold text-white pr-8 mb-3">
            Need assistance?
          </div>
          <div class="text-white font-medium">Give us a call at <a href="tel:8664838644" class="text-green">(866) 483-8644</a> to speak with one of our friendly consultants.
          </div>
          <div
            class="cursor-pointer absolute right-5 top-5 flex items-center justify-center w-4 h-4"
            @click="isHelpDisplayed = false"
          >
            <CloseIcon bg-color="bg-white"/>
          </div>
        </div>
      </transition>
      <Component
        :is="currentQuiz.component"
        @nextStage="nextStage"
      />
    </main>
  </div>
</template>

<script>
import CommonNavbar from "@/components/common/CommonNavbar";
import CommonLogo from "@/components/common/CommonLogo";
import {answersMixin, referMixin} from "@/utils/mixins";
import Welcome from "@/components/quizzes/Welcome";
import CloseIcon from "@/components/icons/CloseIcon";
import AccountCreation from "@/components/quizzes/AccountCreation/AccountCreation";
import SkinAnalysisStart from "@/components/quizzes/SkinAnalysis/SkinAnalysisStart";
import AntiAging from "@/components/quizzes/AntiAging/AntiAging";
import SkinAnalysisEnd from "@/components/quizzes/SkinAnalysis/SkinAnalysisEnd";
import YourResultsAntiAging from "@/components/quizzes/YourResults/YourResultsAntiAging";
import Checkout from "@/components/quizzes/Checkout";
import IdentityVerification from "@/components/quizzes/IdentityVerification";
import Congratulations from "@/components/quizzes/Congratulations";
import ReferOutModal from "@/components/modals/ReferOutModal";

export default {
  mixins: [answersMixin, referMixin],
  name: "PageQuiz",
  components: {ReferOutModal, CloseIcon, CommonLogo, CommonNavbar},
  data() {
    return {
      quizStages: {
        1: {
          component: Welcome,
          displayLogo: true
        },
        2: {
          component: AccountCreation,
          title: 'Account Creation',
          displayBackBtn: true,
        },
        3: {
          component: SkinAnalysisStart,
          title: 'Skin Analysis',
          displayBackBtn: true,
        },
        4: {
          component: AntiAging,
          title: 'Your Health',
          displayBackBtn: true,
        },
        5: {
          component: SkinAnalysisEnd,
          title: 'Your Health',
          displayBackBtn: true
        },
        6: {
          component: YourResultsAntiAging,
          title: 'Your Results',
          displayBackBtn: true
        },
        7: {
          component: Checkout,
          title: 'Checkout',
          displayBackBtn: true
        },
        8: {
          component: IdentityVerification,
          title: 'Identity Verification',
          displayBackBtn: true
        },
        9: {
          component: Congratulations,
          title: 'Congratulations'
        },
      },
      isHelpDisplayed: false,
      currentStageIndex: 1,
    }
  },
  computed: {
    currentQuiz() {
      return this.quizStages[this.currentStageIndex]
    },
    currentStatusNumber() {
      let number = null

      switch (this.currentStageIndex) {
        case 2:
          number = 1
          break;
        case 3:
          number = 2
          break;
        default:
          number = null
      }

      return number
    },
  },
  methods: {
    nextStage() {
      this.currentStageIndex++
    },
  },
}
</script>

<style scoped>

</style>
